`Fiber#raise` should recurse to `resumed_fiber` rather than failing.

04/07/2024 02:17 PM - ioquatix (Samuel Williams)
Target version:    

ruby -v:  Backport: 3.1: REQUIRED, 3.2: WONTFIX, 3.3:

DONE

Description

The following program will fail with FiberError, and is difficult to properly clean up:

root_fiber = Fiber.current

f1 = Fiber.new do

  root_fiber.transfer

end

f2 = Fiber.new do

  f1.resume

end

f2.transfer

f2.raise("error") # => `raise': attempt to transfer to a resuming fiber (FiberError)

 This program deliberately set's up a scenario where f2 is resuming f1. Trying to raise an exception on f2 is impossible, because the

only way control flow can return to it, is when f1 yields or exits.

We can avoid this problem, by raising the exception on f1, and we can do this automatically using the following logic:

static VALUE

fiber_raise(rb_fiber_t *fiber, VALUE exception)

{

    // Add this recursive step:

    if (fiber->resuming_fiber) {

        return fiber_raise(fiber->resuming_fiber, exception);

    }

    // Existing code ...

    else if (FIBER_SUSPENDED_P(fiber) && !fiber->yielding) {

        return fiber_transfer_kw(fiber, -1, &exception, RB_NO_KEYWORDS);

    }

    else {

        return fiber_resume_kw(fiber, -1, &exception, RB_NO_KEYWORDS);

    }

}

 This makes Fiber#raise much more robust and useful for the purpose of stopping fibers, without knowing exactly what they are doing.

Related issues:

Related to Ruby - Feature #20102: Introduce `Fiber#resuming?` Closed

Related to Ruby - Bug #20089: Fiber#kill transfers to root fiber Assigned

Associated revisions

Revision 5c06e930748ef6bdb4ac4751ba16b7b604da3db0 - 05/29/2024 10:47 PM - k0kubun (Takashi Kokubun)

merge revision(s) 6ade36c06b7cef948099b8f5f483763498705d12: [Backport #20414]

    `Fiber#raise` recursively raises on nested resuming_fiber. (#10482)

    * Improve consistency of `Fiber.current.raise`.
Revision 5c06e930748ef6bdb4ac4751ba16b7b604da3db0 - 05/29/2024 10:47 PM - k0kubun (Takashi Kokubun)

merge revision(s) 6ade36c06b7cef948099b8f5f483763498705d12: [Backport #20414]

    `Fiber#raise` recursively raises on nested resuming_fiber. (#10482)

    * Improve consistency of `Fiber.current.raise`.

Revision 5c06e930 - 05/29/2024 10:47 PM - k0kubun (Takashi Kokubun)

merge revision(s) 6ade36c06b7cef948099b8f5f483763498705d12: [Backport #20414]

    `Fiber#raise` recursively raises on nested resuming_fiber. (#10482)

    * Improve consistency of `Fiber.current.raise`.

Revision 2f8f17e842666abb05ca522d6072c957fab0e12e - 07/06/2024 02:16 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 5d1702e01a36e11b183fe29ce10780a9b1a41cf0: [Backport #20414]

    Enumerator should use a non-blocking fiber, change `rb_fiber_new` to be non-blocking by default. (#10481)

Revision 2f8f17e842666abb05ca522d6072c957fab0e12e - 07/06/2024 02:16 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 5d1702e01a36e11b183fe29ce10780a9b1a41cf0: [Backport #20414]

    Enumerator should use a non-blocking fiber, change `rb_fiber_new` to be non-blocking by default. (#10481)

Revision 2f8f17e8 - 07/06/2024 02:16 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 5d1702e01a36e11b183fe29ce10780a9b1a41cf0: [Backport #20414]

    Enumerator should use a non-blocking fiber, change `rb_fiber_new` to be non-blocking by default. (#10481)

History

#1 - 04/07/2024 02:23 PM - ioquatix (Samuel Williams)

Proposed change: https://github.com/ruby/ruby/pull/10482

#2 - 04/07/2024 02:23 PM - ioquatix (Samuel Williams)

- Related to Feature #20102: Introduce `Fiber#resuming?` added

#3 - 04/07/2024 02:24 PM - ioquatix (Samuel Williams)

- Description updated

#4 - 04/07/2024 02:26 PM - ioquatix (Samuel Williams)

With the proposed change, the following program:

root_fiber = Fiber.current

f1 = Fiber.new do

  puts "f1 enter"

  root_fiber.transfer

  puts "f1 exit"

ensure

  puts "f1 ensure"

end

f2 = Fiber.new do

  puts "f2 enter"

  f1.resume

  puts "f2 exit"

ensure

  puts "f2 ensure"

end

f2.transfer

begin

  puts "raise"

  f2.raise(Interrupt)

rescue Interrupt => e
  puts "rescue Interrupt"

end

 ... generates the following output:

f2 enter

f1 enter

raise

f1 ensure

f2 ensure

rescue Interrupt

#5 - 04/07/2024 10:28 PM - ioquatix (Samuel Williams)

- Related to Bug #20089: Fiber#kill transfers to root fiber added

#6 - 04/17/2024 06:19 AM - matz (Yukihiro Matsumoto)

I see no problem in the proposal. I agree.

Matz.

#7 - 04/17/2024 10:03 AM - ioquatix (Samuel Williams)

Thanks @matz (Yukihiro Matsumoto).

To clarify, there are two issues are we addressing.

(1) Improve consistency of Thread.current.raise and Fiber.current.raise.

(2) Follow resuming_fiber when raising exceptions.

They overlap, so are addressed by the same PR.

#8 - 04/17/2024 11:36 AM - ioquatix (Samuel Williams)

- Status changed from Open to Closed

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED

Merged in https://github.com/ruby/ruby/commit/6ade36c06b7cef948099b8f5f483763498705d12.

#9 - 05/29/2024 10:48 PM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE

ruby_3_3 5c06e930748ef6bdb4ac4751ba16b7b604da3db0 merged revision(s) 6ade36c06b7cef948099b8f5f483763498705d12.

#10 - 07/06/2024 02:13 AM - nagachika (Tomoyuki Chikanaga)

I think this change seems somewhat like a spec change. Could this change potentially reveal latent errors in the application and affect its operation?

Additionally, regardless of the case, I believe the ruby_version_is guard in rubyspec will need to be updated if we backport it to stable branches.

#11 - 07/06/2024 02:20 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE to 3.1: REQUIRED, 3.2: DONE, 3.3: DONE

ruby_3_2 2f8f17e842666abb05ca522d6072c957fab0e12e merged revision(s) 5d1702e01a36e11b183fe29ce10780a9b1a41cf0.

#12 - 07/06/2024 02:22 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: REQUIRED, 3.2: DONE, 3.3: DONE to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE

Sorry, I accidentally changed a different ticket.

#13 - 07/20/2024 03:57 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE to 3.1: REQUIRED, 3.2: WONTFIX, 3.3: DONE
